当前位置:   article > 正文

Leetcode 127. 单词接龙【构图+BFS】_给定两个单词beginword

给定两个单词beginword

问题描述

给定两个单词(beginWord 和 endWord)和一个字典,找到从 beginWord 到 endWord 的最短转换序列的长度。转换需遵循如下规则:

  • 每次转换只能改变一个字母。
  • 转换过程中的中间单词必须是字典中的单词。
    说明:

如果不存在这样的转换序列,返回 0。
所有单词具有相同的长度。
所有单词只由小写字母组成。
字典中不存在重复的单词。
你可以假设 beginWord 和 endWord 是非空的,且二者不相同。
示例 1:

输入:
beginWord = “hit”,
endWord = “cog”,
wordList = [“hot”,“dot”,“dog”,“lot”,“log”,“cog”]

输出: 5

解释: 一个最短转换序列是 “hit” -> “hot” -> “dot” -> “dog” -> “cog”,
返回它的长度 5。

解题报告

我可能太傻了,完全没想到将序列的转换过程构建成图。

想到构图,然后在图上找最短路径,这题就简单许多了。

  • 构图方式
    将词典中的每两个单词进行比对,如果满足转换条件,则在这两个单词之间连上线。
  • 在构建好的图上进行BFS
    cost[] 表示每个单词到 beginWord 的最短路径,除了 cost[beginWord] 初始化为 1【因为长度包括 beginWord 本身】,其他值初始化为 INT_MAX
    最后返回 cost[dest] 即可。

实现代码

class Solution {
private:
    unordered_map<string, int> wordId;
    vector<string> idWord;
    vector<vector<int>> edges;
public:
    int ladderLength(string beginWord, string endWord, vector<string>& wordList) {
        int id = 0;
        for (const string& word : wordList) {
            if (!wordId.count(word)) {
                wordId[word] = id++;
                idWord.push_back(word);
            }
        }
        if (!wordId.count(endWord)) {
            return 0;
        }
        if (!wordId.count(beginWord)) {
            wordId[beginWord] = id++;
            idWord.push_back(beginWord);
        }
        edges.resize(idWord.size());
        for (int i = 0; i < idWord.size(); i++) {
            for (int j = i + 1; j < idWord.size(); j++) {
                if (transformCheck(idWord[i], idWord[j])) {
                    edges[i].push_back(j);
                    edges[j].push_back(i);
                }
            }
        }
        const int dest = wordId[endWord];
        queue<int>q;
        vector<int>cost(id, INT_MAX);
        q.push(wordId[beginWord]);
        cost[wordId[beginWord]]=1;
        while(!q.empty()){
            int now=q.front();
            q.pop();
            for(int i=0;i<edges[now].size();i++){
                int to=edges[now][i];
                if(cost[now]+1<=cost[to]){
                    cost[to]=cost[now]+1;
                    q.push(to);
                }
            }
        }
        return cost[dest]==INT_MAX?0:cost[dest];
    }
     bool transformCheck(const string& str1, const string& str2) {
        int differences = 0;
        for (int i = 0; i < str1.size() && differences < 2; i++) {
            if (str1[i] != str2[i]) {
                ++differences;
            }
        }
        return differences == 1;
    }
};
  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12
  • 13
  • 14
  • 15
  • 16
  • 17
  • 18
  • 19
  • 20
  • 21
  • 22
  • 23
  • 24
  • 25
  • 26
  • 27
  • 28
  • 29
  • 30
  • 31
  • 32
  • 33
  • 34
  • 35
  • 36
  • 37
  • 38
  • 39
  • 40
  • 41
  • 42
  • 43
  • 44
  • 45
  • 46
  • 47
  • 48
  • 49
  • 50
  • 51
  • 52
  • 53
  • 54
  • 55
  • 56
  • 57
  • 58

参考资料

[1] Leetcode 127. 单词接龙
[2] 官方题解

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/羊村懒王/article/detail/718578
推荐阅读
相关标签
  

闽ICP备14008679号